<template>
  <article class="post">
    <PostTitle :title="title"/>
    <PostContent :content="body" :timestamp="timestamp"/>
    <PostComments/>
  </article>
</template>

<script lang="ts">
import { Component, Prop, Vue } from 'vue-property-decorator';
import PostTitle from '@/components/PostTitle.vue';
import PostContent from '@/components/PostContent.vue';
import PostComments from '@/components/PostComments.vue';
import axios from 'axios';

@Component({
  components: {
    PostTitle,
    PostContent,
    PostComments,
  },
})

export default class Post extends Vue {
public body!: any;
@Prop() private title!: any;

  public data() {
    return {
      title: '',
      body: '',
      timestamp: '',
    };
  }

  public async beforeCreate() {
    const postID = (this.$route.params.id);

    const result = await axios({
    method: 'POST',
    url: 'http://localhost:4020/graphql',
    data: {
          query: `
              {
                getPost(
                  _id: "${postID}"
                ){
                  title
                  body
                  _id
                  timestamp
                  author
                  likes
                }
              }
          `,
      },
  });
    this.title = result.data.data.getPost.title;
    this.body = result.data.data.getPost.body;
    this.timestamp = result.data.data.getPost.timestamp;
  }


}
</script>
